FFOO
====

SYNOPSIS
--------

    #!/bin/bash
    # ~/bin/example
    source <(ffoom init)
    ffoo import core

    # basic echo helpers
    think "about saying something..."   # like echo if FFOO_VERBOSE
    warn "this is just an example"      # obvious :)
    false || die "false was true!"      # Perlism :)
    x=1; y=2; z=3
    debug "x=$x" "y=$y" "z=$z"          # debug:example: x=1
                                        # debug:example: y=2
                                        # debug:example: z=3
    debug -v x y z                      # short for above!
    echo "hello" | debug_pipe mypipe    # debug:PIPE mypipe: hello

    # more advanced functions
    ffoo import ini
    FFOO_DATADIR=$HOME/.example
    cat >$FFOO_DATADIR/main.ini <<EOF
    # a sample ini file
    [mysection]
        key = something
        multiline = also possible
        multiline = like this :)
    [scripts]
        s1 =#!/usr/bin/python
        s1 =def main():
        s1 =    print "will work!"
    EOF
    iniread -s mysection -k mykey main.ini  # prints "something"
    iniread -S -k s1 > sample.py            # why section? with unique key...
    python sample.py                        # "will work!" due to the -S

    # even more
    ffoo import recon
    wait_until -e ! test -e badfile         # -e means use eval (make "!" work)
    think "the badfile is away..."
    bad_file_away() {                       # but you can avoid eval
        ! test -f badfile
    }
    wait_until bad_file_away

    # ... and more
    ffoo import recon
    register_artifact this_file_will_exist.log
    some_important_program > this_file_will_exist.log
    collect_artifacts                       # will preserve tree from /

    # ...AND MORE!
    ffoo import sw
    cat > dependencies.ini <<EOF
    [needs/now]
        yum = ronn
        yum = vim
        pypi = docopt
    [needs/for_test]
        cpan = Test::More
    # yeah I made that up
    EOF
    iniread ./dependencies.ini | any_install




AUTHOR
------

Alois Mahdal
